

<meta content="text/html; charset=UTF-8" http-equiv="Content-Type">
<meta name="keywords" content="disk encryption, security, transparent, AES, plausible deniability, virtual drive, Linux, MS Windows, portable, USB drive, partition">
<meta name="description" content="DoxBox: An Open-Source transparent encryption program for PCs. With this software, you can create one or more &quot;DoxBoxes&quot; on your PC - which appear as disks, anything written to these disks is automatically encrypted before being stored on your hard drive.">

<meta name="author" content="Sarah Dean">
<meta name="copyright" content="Copyright 2004, 2005, 2006, 2007, 2008 Sarah Dean">


<TITLE>Contents</TITLE>

<link href="https://raw.githubusercontent.com/t-d-k/doxbox/master/docs/styles_common.css" rel="stylesheet" type="text/css">


<link rel="shortcut icon" href="https://github.com/t-d-k/doxbox/raw/master/src/Common/Common/images/DoxBox.ico" type="image/x-icon">

<SPAN CLASS="master_link">
[![DoxBox logo](../src/Common/Common/images/DoxBox64.png)](http://DoxBox.eu/)
</SPAN>
<SPAN CLASS="master_title">
_[DoxBox](http://DoxBox.eu/): Open-Source disk encryption for Windows_
</SPAN>
***

<SPAN class="tip">
The latest version of this document can be found at the [DoxBox project site](https://github.com/t-d-k/doxbox)
</SPAN>

      
* [Introduction](description.html)
* [Download](download.html)
* [Installation and Upgrading](installation_and_upgrading__PC.html)

	+ [Windows Vista	x64 / Windows	7	x64 Additional](impact_of_kernel_driver_signing.html)

* [Getting Started](getting_started.html)
* [Advanced Topics](advanced_topics.html)
* [Portable Mode](portable_mode.html)
* [Security Token/Smartcard Support](pkcs11_support.html)
* [Command Line Interface](command_line.html)
* [Linux Volumes](Linux_volumes.html)

	+ [Examples: Cryptoloop](Linux_examples__cryptoloop.html)
	+ [Examples: dm-crypt](Linux_examples__dm-crypt.html)
	+ [Examples: LUKS](Linux_examples__LUKS.html)
	
* [Plausible Deniability](plausible_deniability.html)
* [Miscellaneous Notes](notes.html)

	+ [PC Version Specific](notes_PC.html)


* [FAQ](FAQ.html)
* [Technical Details](technical_details.html)


* [Volumes and Keyfiles](technical_details__FreeOTFE_volumes_and_keyfiles.html)

* [Critical Data Block Layouts](technical_details__FreeOTFE_CDB_layout.html)

	+ [Format ID 1](technical_details__FreeOTFE_CDB_layout_format_1.html)
	+ [Format ID 2](technical_details__FreeOTFE_CDB_layout_format_2.html)
	+ [Format ID 3](technical_details__FreeOTFE_CDB_layout_format_3.html)
	+ [Format ID 4](technical_details__FreeOTFE_CDB_layout_format_4.html)


* [Creating Volumes](technical_details__creating_FreeOTFE_volumes.html)
* [Mounting Volumes](technical_details__mounting_FreeOTFE_volumes.html)
* [Encrypted Partition Image Encryption/Decryption](technical_details__partition_encryption_decryption.html)
* [Registry Entries](technical_details__registry_entries.html)
* [Random Number Generators (RNGs)](technical_details__RNGs.html)
* [Building the Software](technical_details__build_notes.html)
* [Creating a New Hash/Cypher Driver](technical_details__creating_a_new_hash_cypher_driver.html)
* [Filename Extensions](technical_details__filename_extensions.html)

* [Known Bugs](known_bugs.html)
* [Fault/Bug Reporting](fault_reporting.html)
* [TODO List](TODO_list.html)
* [Appendix A: Version History](version_history.html)
* [Appendix B: Credits](credits.html)
* [Appendix C: Licence](licence.html)
* [Appendix D: Glossary](glossary.html)
* [Appendix E: PKCS#11 Driver Libraries](pkcs11_drivers.html)
* [Appendix F: Command Line Decryption Utilities](command_line_decryption_utilities.html)
* [Appendix G: Uninstalling](uninstalling.html)
* [Appendix H: Contact Details](contact_details.html)

 



